import*as i18n from"../../../core/i18n/i18n.js";import*as Buttons from"../../../ui/components/buttons/buttons.js";import*as ComponentHelpers from"../../../ui/components/helpers/helpers.js";import*as IconButton from"../../../ui/components/icon_button/icon_button.js";import*as UI from"../../../ui/legacy/legacy.js";import*as LitHtml from"../../../ui/lit-html/lit-html.js";import*as Menus from"../../../ui/components/menus/menus.js";import*as Models from"../models/models.js";import stepViewStyles from"./stepView.css.js";import{TimelineSection}from"./TimelineSection.js";const UIStrings={setViewportClickTitle:"Set viewport",customStepTitle:"Custom step",clickStepTitle:"Click",doubleClickStepTitle:"Double click",hoverStepTitle:"Hover",emulateNetworkConditionsStepTitle:"Emulate network conditions",changeStepTitle:"Change",closeStepTitle:"Close",scrollStepTitle:"Scroll",keyUpStepTitle:"Key up",navigateStepTitle:"Navigate",keyDownStepTitle:"Key down",waitForElementStepTitle:"Wait for element",waitForExpressionStepTitle:"Wait for expression",elementRoleButton:"Button",elementRoleInput:"Input",elementRoleFallback:"Element",addStepBefore:"Add step before",addStepAfter:"Add step after",removeStep:"Remove step",openStepActions:"Open step actions",addBreakpoint:"Add breakpoint",removeBreakpoint:"Remove breakpoint",copyAs:"Copy as",stepManagement:"Manage steps",breakpoints:"Breakpoints"},str_=i18n.i18n.registerUIStrings("panels/recorder/components/StepView.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);export class CaptureSelectorsEvent extends Event{static eventName="captureselectors";data;constructor(e){super(CaptureSelectorsEvent.eventName,{bubbles:!0,composed:!0}),this.data=e}}export class StopSelectorsCaptureEvent extends Event{static eventName="stopselectorscapture";constructor(){super(StopSelectorsCaptureEvent.eventName,{bubbles:!0,composed:!0})}}export class CopyStepEvent extends Event{static eventName="copystep";step;constructor(e){super(CopyStepEvent.eventName,{bubbles:!0,composed:!0}),this.step=e}}export class StepChanged extends Event{static eventName="stepchanged";currentStep;newStep;constructor(e,t){super(StepChanged.eventName,{bubbles:!0,composed:!0}),this.currentStep=e,this.newStep=t}}export class AddStep extends Event{static eventName="addstep";position;stepOrSection;constructor(e,t){super(AddStep.eventName,{bubbles:!0,composed:!0}),this.stepOrSection=e,this.position=t}}export class RemoveStep extends Event{static eventName="removestep";step;constructor(e){super(RemoveStep.eventName,{bubbles:!0,composed:!0}),this.step=e}}export class AddBreakpointEvent extends Event{static eventName="addbreakpoint";index;constructor(e){super(AddBreakpointEvent.eventName,{bubbles:!0,composed:!0}),this.index=e}}export class RemoveBreakpointEvent extends Event{static eventName="removebreakpoint";index;constructor(e){super(RemoveBreakpointEvent.eventName,{bubbles:!0,composed:!0}),this.index=e}}const COPY_ACTION_PREFIX="copy-step-as-";export class StepView extends HTMLElement{static litTagName=LitHtml.literal`devtools-step-view`;#e=this.attachShadow({mode:"open"});#t;#s;#i="default";#n;#o=!1;#r=!1;#a=!1;#p=0;#c=0;#l=!1;#d=!1;#h=!1;#u=!1;#S;#g=!1;#m=!1;#v=new IntersectionObserver((e=>{this.#m=e[0].isIntersecting}));#b=!1;#w=!0;#f;#k;#T=!1;#M;set data(e){const t=this.#i;this.#t=e.step,this.#s=e.section,this.#i=e.state,this.#n=e.error,this.#r=e.isEndOfGroup,this.#a=e.isStartOfGroup,this.#p=e.stepIndex,this.#c=e.sectionIndex,this.#l=e.isFirstSection,this.#d=e.isLastSection,this.#h=e.isRecording,this.#u=e.isPlaying,this.#b=e.hasBreakpoint,this.#w=e.removable,this.#f=e.builtInConverters,this.#k=e.extensionConverters,this.#T=e.isSelected,this.#M=e.recorderSettings,this.#I(),this.#i===t||"current"!==this.#i||this.#m||this.scrollIntoView()}get step(){return this.#t}get section(){return this.#s}connectedCallback(){this.#e.adoptedStyleSheets=[stepViewStyles],this.#v.observe(this),this.#I()}disconnectedCallback(){this.#v.unobserve(this)}#E(){this.#o=!this.#o,this.#I()}#y(e){const t=e;"Enter"!==t.key&&" "!==t.key||(this.#E(),e.stopPropagation(),e.preventDefault())}#x(){if(this.#s)return this.#s.title?this.#s.title:LitHtml.html`<span class="fallback">(No Title)</span>`;if(!this.#t)throw new Error("Missing both step and section");switch(this.#t.type){case Models.Schema.StepType.CustomStep:return i18nString(UIStrings.customStepTitle);case Models.Schema.StepType.SetViewport:return i18nString(UIStrings.setViewportClickTitle);case Models.Schema.StepType.Click:return i18nString(UIStrings.clickStepTitle);case Models.Schema.StepType.DoubleClick:return i18nString(UIStrings.doubleClickStepTitle);case Models.Schema.StepType.Hover:return i18nString(UIStrings.hoverStepTitle);case Models.Schema.StepType.EmulateNetworkConditions:return i18nString(UIStrings.emulateNetworkConditionsStepTitle);case Models.Schema.StepType.Change:return i18nString(UIStrings.changeStepTitle);case Models.Schema.StepType.Close:return i18nString(UIStrings.closeStepTitle);case Models.Schema.StepType.Scroll:return i18nString(UIStrings.scrollStepTitle);case Models.Schema.StepType.KeyUp:return i18nString(UIStrings.keyUpStepTitle);case Models.Schema.StepType.KeyDown:return i18nString(UIStrings.keyDownStepTitle);case Models.Schema.StepType.WaitForElement:return i18nString(UIStrings.waitForElementStepTitle);case Models.Schema.StepType.WaitForExpression:return i18nString(UIStrings.waitForExpressionStepTitle);case Models.Schema.StepType.Navigate:return i18nString(UIStrings.navigateStepTitle)}}#$(e){switch(e){case"button":return i18nString(UIStrings.elementRoleButton);case"input":return i18nString(UIStrings.elementRoleInput);default:return i18nString(UIStrings.elementRoleFallback)}}#C(){if(!this.#t||!("selectors"in this.#t))return"";const e=this.#t.selectors.flat().find((e=>e.startsWith("aria/")));if(!e)return"";const t=e.match(/^aria\/(.+?)(\[role="(.+)"\])?$/);return t?`${this.#$(t[3])} "${t[1]}"`:""}#B(){return this.#s?this.#s.url:""}#U(e){const t=this.#t||this.#s?.causingStep;if(!t)throw new Error("Expected step.");this.dispatchEvent(new StepChanged(t,e.data))}#N(e){switch(e.itemValue){case"add-step-before":{const e=this.#t||this.#s;if(!e)throw new Error("Expected step or section.");this.dispatchEvent(new AddStep(e,"before"));break}case"add-step-after":{const e=this.#t||this.#s;if(!e)throw new Error("Expected step or section.");this.dispatchEvent(new AddStep(e,"after"));break}case"remove-step":{const e=this.#s?.causingStep;if(!this.#t&&!e)throw new Error("Expected step.");this.dispatchEvent(new RemoveStep(this.#t||e));break}case"add-breakpoint":if(!this.#t)throw new Error("Expected step");this.dispatchEvent(new AddBreakpointEvent(this.#p));break;case"remove-breakpoint":if(!this.#t)throw new Error("Expected step");this.dispatchEvent(new RemoveBreakpointEvent(this.#p));break;default:{const t=e.itemValue;if(!t.startsWith("copy-step-as-"))throw new Error("Unknown step action.");const s=this.#t||this.#s?.causingStep;if(!s)throw new Error("Step not found.");const i=t.substring(13);this.#M&&(this.#M.preferredCopyFormat=i),this.dispatchEvent(new CopyStepEvent(structuredClone(s)))}}}#A(e){e.stopPropagation(),e.preventDefault(),this.#g=!this.#g,this.#I()}#L(){this.#g=!1,this.#I()}#H(){this.#b?this.dispatchEvent(new RemoveBreakpointEvent(this.#p)):this.dispatchEvent(new AddBreakpointEvent(this.#p)),this.#I()}#R(){if(!this.#S)throw new Error("Missing actionsMenuButton");return this.#S}#D=()=>{const e=[];if(this.#u||(this.#t&&e.push({id:"add-step-before",label:i18nString(UIStrings.addStepBefore),group:"stepManagement",groupTitle:i18nString(UIStrings.stepManagement)}),e.push({id:"add-step-after",label:i18nString(UIStrings.addStepAfter),group:"stepManagement",groupTitle:i18nString(UIStrings.stepManagement)}),this.#w&&e.push({id:"remove-step",group:"stepManagement",groupTitle:i18nString(UIStrings.stepManagement),label:i18nString(UIStrings.removeStep)})),this.#t&&!this.#h&&(this.#b?e.push({id:"remove-breakpoint",label:i18nString(UIStrings.removeBreakpoint),group:"breakPointManagement",groupTitle:i18nString(UIStrings.breakpoints)}):e.push({id:"add-breakpoint",label:i18nString(UIStrings.addBreakpoint),group:"breakPointManagement",groupTitle:i18nString(UIStrings.breakpoints)})),this.#t){for(const t of this.#f||[])e.push({id:"copy-step-as-"+t.getId(),label:t.getFormatName(),group:"copy",groupTitle:i18nString(UIStrings.copyAs)});for(const t of this.#k||[])e.push({id:"copy-step-as-"+t.getId(),label:t.getFormatName(),group:"copy",groupTitle:i18nString(UIStrings.copyAs)})}return e};#F(){const e=this.#D(),t=new Map;for(const s of e){const e=t.get(s.group);e?e.push(s):t.set(s.group,[s])}const s=[];for(const[e,i]of t)s.push({group:e,groupTitle:i[0].groupTitle,actions:i});return LitHtml.html`
      <${Buttons.Button.Button.litTagName}
        class="step-actions"
        title=${i18nString(UIStrings.openStepActions)}
        aria-label=${i18nString(UIStrings.openStepActions)}
        @click=${this.#A}
        @keydown=${e=>{e.stopPropagation()}}
        on-render=${ComponentHelpers.Directives.nodeRenderedCallback((e=>{this.#S=e}))}
        .data=${{variant:"toolbar",iconName:"dots-vertical",title:i18nString(UIStrings.openStepActions)}}
      ></${Buttons.Button.Button.litTagName}>
      <${Menus.Menu.Menu.litTagName}
        @menucloserequest=${this.#L}
        @menuitemselected=${this.#N}
        .origin=${this.#R.bind(this)}
        .showSelectedItem=${!1}
        .showConnector=${!1}
        .open=${this.#g}
      >
        ${LitHtml.Directives.repeat(s,(e=>e.group),(e=>LitHtml.html`
            <${Menus.Menu.MenuGroup.litTagName}
              .name=${e.groupTitle}
            >
              ${LitHtml.Directives.repeat(e.actions,(e=>e.id),(e=>LitHtml.html`<${Menus.Menu.MenuItem.litTagName}
                      .value=${e.id}
                    >
                      ${e.label}
                    </${Menus.Menu.MenuItem.litTagName}>
                  `))}
            </${Menus.Menu.MenuGroup.litTagName}>
          `))}
      </${Menus.Menu.Menu.litTagName}>
    `}#O=e=>{if(2!==e.button)return;const t=new UI.ContextMenu.ContextMenu(e),s=this.#D(),i=s.filter((e=>e.id.startsWith("copy-step-as-"))),n=s.filter((e=>!e.id.startsWith("copy-step-as-")));for(const e of n){t.section(e.group).appendItem(e.label,(()=>{this.#N(new Menus.Menu.MenuItemSelectedEvent(e.id))}))}const o=i.find((e=>e.id==="copy-step-as-"+this.#M?.preferredCopyFormat));if(o&&t.section("copy").appendItem(o.label,(()=>{this.#N(new Menus.Menu.MenuItemSelectedEvent(o.id))})),i.length){const e=t.section("copy").appendSubMenuItem(i18nString(UIStrings.copyAs));for(const t of i)t!==o&&e.section(t.group).appendItem(t.label,(()=>{this.#N(new Menus.Menu.MenuItemSelectedEvent(t.id))}))}t.show()};#I(){if(!this.#t&&!this.#s)return;const e={step:!0,expanded:this.#o,"is-success":"success"===this.#i,"is-current":"current"===this.#i,"is-outstanding":"outstanding"===this.#i,"is-error":"error"===this.#i,"is-stopped":"stopped"===this.#i,"is-start-of-group":this.#a,"is-first-section":this.#l,"has-breakpoint":this.#b},t=Boolean(this.#t),s=this.#x(),i=this.#t?this.#C():this.#B();LitHtml.render(LitHtml.html`
      <${TimelineSection.litTagName} .data=${{isFirstSection:this.#l,isLastSection:this.#d,isStartOfGroup:this.#a,isEndOfGroup:this.#r,isSelected:this.#T}} @contextmenu=${this.#O} data-step-index=${this.#p} data-section-index=${this.#c} class=${LitHtml.Directives.classMap(e)}>
        <svg slot="icon" width="24" height="24" height="100%" class="icon">
          <circle class="circle-icon"/>
          <g class="error-icon">
            <path d="M1.5 1.5L6.5 6.5" stroke="white" stroke-width="1.5" stroke-linecap="round" stroke-linejoin="round"/>
            <path d="M1.5 6.5L6.5 1.5" stroke="white" stroke-width="1.5" stroke-linecap="round" stroke-linejoin="round"/>
          </g>
          <path @click=${this.#H.bind(this)} class="breakpoint-icon" d="M2.5 5.5H17.7098L21.4241 12L17.7098 18.5H2.5V5.5Z"/>
        </svg>
        <div class="summary">
          <div class="title-container ${t?"action":""}"
            @click=${t&&this.#E.bind(this)}
            @keydown=${t&&this.#y.bind(this)}
            tabindex="0"
            aria-role=${t?"button":""}
            aria-label=${t?"Show details for step":""}
          >
            ${t?LitHtml.html`<${IconButton.Icon.Icon.litTagName}
                    class="chevron"
                    .data=${{iconName:"triangle-down",color:"var(--sys-color-on-surface)"}}>
                  </${IconButton.Icon.Icon.litTagName}>`:""}
            <div class="title">
              <div class="main-title" title=${s}>${s}</div>
              <div class="subtitle" title=${i}>${i}</div>
            </div>
          </div>
          <div class="filler"></div>
          ${this.#F()}
        </div>
        <div class="details">
          ${this.#t&&LitHtml.html`<devtools-recorder-step-editor
            class=${this.#T?"is-selected":""}
            .step=${this.#t}
            .disabled=${this.#u}
            @stepedited=${this.#U}>
          </devtools-recorder-step-editor>`}
          ${this.#s?.causingStep&&LitHtml.html`<devtools-recorder-step-editor
            .step=${this.#s.causingStep}
            .isTypeEditable=${!1}
            .disabled=${this.#u}
            @stepedited=${this.#U}>
          </devtools-recorder-step-editor>`}
        </div>
        ${this.#n&&LitHtml.html`
          <div class="error" role="alert">
            ${this.#n.message}
          </div>
        `}
      </${TimelineSection.litTagName}>
    `,this.#e,{host:this})}}ComponentHelpers.CustomElements.defineComponent("devtools-step-view",StepView);