const styles=new CSSStyleSheet;styles.replaceSync('/*\n * Copyright 2016 The Chromium Authors. All rights reserved.\n * Use of this source code is governed by a BSD-style license that can be\n * found in the LICENSE file.\n */\n\n.tree-outline {\n  padding-left: 0;\n\n  --override-error-background-color: #d93025;\n  --override-error-text-color: #fff;\n  --override-call-to-action-border-color: #f29900;\n  --override-header-highlight-background-color: #ffff78;\n}\n\n.-theme-with-dark-background .tree-outline,\n:host-context(.-theme-with-dark-background) .tree-outline {\n  --override-error-text-color: #000;\n  --override-call-to-action-border-color: rgb(255 166 13);\n  --override-header-highlight-background-color: rgb(135 135 0);\n}\n\n.tree-outline > ol {\n  padding-bottom: 5px;\n  border-bottom: solid 1px var(--sys-color-divider);\n}\n\n.tree-outline > .parent {\n  user-select: none;\n  font-weight: bold;\n  color: var(--color-text-primary);\n  margin-top: -1px;\n  display: flex;\n  align-items: center;\n  height: 26px;\n}\n\n.tree-outline li {\n  display: block;\n  padding-left: 5px;\n  line-height: 20px;\n}\n\n.tree-outline li:not(.parent) {\n  margin-left: 10px;\n}\n\n.tree-outline li:not(.parent)::before {\n  display: none;\n}\n\n.tree-outline .caution {\n  margin-left: 4px;\n  display: inline-block;\n  font-weight: bold;\n}\n\n.tree-outline li.expanded .header-count {\n  display: none;\n}\n\n.tree-outline li .headers-title-left {\n  min-width: 50%;\n  display: flex;\n  justify-content: space-between;\n}\n\n.tree-outline li .header-toggle {\n  display: none;\n}\n\n.tree-outline li .status-from-cache {\n  color: var(--color-text-secondary);\n}\n\n.tree-outline li.expanded .header-toggle {\n  display: inline;\n  margin-left: 30px;\n  font-weight: normal;\n  color: var(--color-text-primary);\n}\n\n.tree-outline li .header-toggle:hover {\n  color: var(--color-text-secondary);\n  cursor: pointer;\n}\n\n.tree-outline .header-name {\n  color: var(--color-text-secondary);\n  display: inline-block;\n  margin-right: 0.25em;\n  font-weight: bold;\n  vertical-align: top;\n  white-space: pre-wrap;\n}\n\n.tree-outline .header-separator {\n  user-select: none;\n}\n\n.tree-outline .header-badge-text {\n  font-variant: small-caps;\n  font-weight: 500;\n  white-space: pre-wrap;\n  word-break: break-all;\n}\n\n.tree-outline .header-warning {\n  color: var(--override-error-background-color);\n}\n\n.tree-outline .header-badge {\n  display: inline;\n  margin-right: 0.75em;\n  background-color: var(--override-error-background-color);\n  color: var(--override-error-text-color);\n  border-radius: 100vh;\n  padding-left: 6px;\n  padding-right: 6px;\n}\n\n.tree-outline .header-value {\n  display: inline;\n  margin-right: 1em;\n  white-space: pre-wrap;\n  word-break: break-all;\n  margin-top: 1px;\n}\n\n.tree-outline .call-to-action {\n  background-color: var(--color-background-elevation-1);\n  padding: 8px;\n  border-radius: 2px;\n}\n\n.tree-outline .selected .call-to-action {\n  background-color: transparent;\n  padding: 8px;\n  border-radius: 2px;\n}\n\n.tree-outline .call-to-action-body {\n  padding: 6px 0;\n  margin-left: 9.5px;\n  border-left: 2px solid var(--override-call-to-action-border-color);\n  padding-left: 18px;\n}\n\n.tree-outline .call-to-action .explanation {\n  font-weight: bold;\n}\n\n.tree-outline .call-to-action code {\n  font-size: 90%;\n}\n\n.tree-outline .call-to-action .example .comment::before {\n  content: " — ";\n}\n\n.tree-outline .empty-request-header {\n  color: var(--color-text-disabled);\n}\n\n.request-headers-show-more-button {\n  border: none;\n  border-radius: 3px;\n  display: inline-block;\n  font-size: 12px;\n  font-family: sans-serif;\n  cursor: pointer;\n  margin: 0 4px;\n  padding: 2px 4px;\n}\n\n.request-headers-caution {\n  display: flex;\n  gap: 6px;\n  margin-right: 20px;\n  padding: 8px;\n  background-color: var(--sys-color-neutral-container);\n  border-radius: 5px;\n}\n\n.header-highlight {\n  background-color: var(--sys-color-state-focus-highlight);\n}\n\n.header-highlight:focus {\n  background-color: var(--sys-color-state-ripple-primary);\n}\n\n.x-client-data-details {\n  padding-left: 10px;\n}\n\n@media (forced-colors: active) {\n  :host-context(.request-headers-tree) ol.tree-outline:not(.hide-selection-when-blurred) li.selected:focus {\n    background: Highlight;\n  }\n\n  :host-context(.request-headers-tree) ol.tree-outline:not(.hide-selection-when-blurred) li::before {\n    background-color: ButtonText;\n  }\n\n  :host-context(.request-headers-tree) ol.tree-outline:not(.hide-selection-when-blurred) li.selected.parent::before {\n    background-color: HighlightText;\n  }\n\n  :host-context(.request-headers-tree) ol.tree-outline:not(.hide-selection-when-blurred) li.selected *,\n  :host-context(.request-headers-tree) ol.tree-outline:not(.hide-selection-when-blurred) li.selected.parent,\n  :host-context(.request-headers-tree) ol.tree-outline:not(.hide-selection-when-blurred) li.selected.parent span,\n  :host-context(.request-headers-tree) ol.tree-outline:not(.hide-selection-when-blurred) li.selected:focus .status-from-cache {\n    color: HighlightText;\n  }\n}\n\n.header-decode-error {\n  color: var(--color-accent-red);\n}\n\n.headers-title {\n  display: flex;\n  justify-content: space-between;\n  width: 100%;\n  padding-right: 5px;\n}\n\n.tree-outline li .headers-link {\n  display: none;\n}\n\n.tree-outline li.expanded .headers-link {\n  display: inline;\n  color: var(--color-text-primary);\n}\n\n/*# sourceURL=requestHeadersTree.css */\n');export default styles;