import{EMPTY,catchError,defaultIfEmpty,defer,filter,first,firstValueFrom,from,fromEvent,identity,ignoreElements,map,merge,mergeMap,noop,pipe,raceWith,retry,tap,timer}from"../../../third_party/rxjs/rxjs.js";import{TimeoutError}from"../../common/Errors.js";import{EventEmitter}from"../../common/EventEmitter.js";import{debugError}from"../../common/util.js";import{FilteredLocator,MappedLocator,RaceLocator}from"./locators.js";export const RETRY_DELAY=100;export var LocatorEmittedEvents;!function(e){e.Action="action"}(LocatorEmittedEvents||(LocatorEmittedEvents={}));export class Locator extends EventEmitter{static race(e){return RaceLocator.create(e)}visibility=null;_timeout=3e4;#e=!0;#t=!0;#r=!0;operators={conditions:(e,t)=>mergeMap((r=>merge(...e.map((e=>e(r,t)))).pipe(defaultIfEmpty(r)))),retryAndRaceWithSignalAndTimer:e=>{const t=[];return e&&t.push(fromEvent(e,"abort").pipe(map((()=>{throw e.reason})))),this._timeout>0&&t.push(timer(this._timeout).pipe(map((()=>{throw new TimeoutError(`Timed out after waiting ${this._timeout}ms`)})))),pipe(retry({delay:100}),raceWith(...t))}};get timeout(){return this._timeout}on(e,t){return super.on(e,t)}once(e,t){return super.once(e,t)}off(e,t){return super.off(e,t)}setTimeout(e){const t=this._clone();return t._timeout=e,t}setVisibility(e){const t=this._clone();return t.visibility=e,t}setWaitForEnabled(e){const t=this._clone();return t.#t=e,t}setEnsureElementIsInTheViewport(e){const t=this._clone();return t.#e=e,t}setWaitForStableBoundingBox(e){const t=this._clone();return t.#r=e,t}copyOptions(e){return this._timeout=e._timeout,this.visibility=e.visibility,this.#t=e.#t,this.#e=e.#e,this.#r=e.#r,this}#i=(e,t)=>this.#t?from(e.frame.waitForFunction((e=>{if(!(e instanceof HTMLElement))return!0;return!["BUTTON","INPUT","SELECT","TEXTAREA","OPTION","OPTGROUP"].includes(e.nodeName)||!e.hasAttribute("disabled")}),{timeout:this._timeout,signal:t},e)).pipe(ignoreElements()):EMPTY;#n=e=>this.#r?defer((()=>from(e.evaluate((e=>new Promise((t=>{window.requestAnimationFrame((()=>{const r=e.getBoundingClientRect();window.requestAnimationFrame((()=>{const i=e.getBoundingClientRect();t([{x:r.x,y:r.y,width:r.width,height:r.height},{x:i.x,y:i.y,width:i.width,height:i.height}])}))}))}))))))).pipe(first((([e,t])=>e.x===t.x&&e.y===t.y&&e.width===t.width&&e.height===t.height)),retry({delay:100}),ignoreElements()):EMPTY;#o=e=>this.#e?from(e.isIntersectingViewport({threshold:0})).pipe(filter((e=>!e)),mergeMap((()=>from(e.scrollIntoView()))),mergeMap((()=>defer((()=>from(e.isIntersectingViewport({threshold:0})))).pipe(first(identity),retry({delay:100}),ignoreElements())))):EMPTY;#a(e){const t=e?.signal;return this._wait(e).pipe(this.operators.conditions([this.#o,this.#n,this.#i],t),tap((()=>this.emit(LocatorEmittedEvents.Action))),mergeMap((t=>from(t.click(e)).pipe(catchError(((e,r)=>(t.dispose().catch(debugError),r)))))),this.operators.retryAndRaceWithSignalAndTimer(t))}#s(e,t){const r=t?.signal;return this._wait(t).pipe(this.operators.conditions([this.#o,this.#n,this.#i],r),tap((()=>this.emit(LocatorEmittedEvents.Action))),mergeMap((t=>from(t.evaluate((e=>e instanceof HTMLSelectElement?"select":e instanceof HTMLTextAreaElement?"typeable-input":e instanceof HTMLInputElement?new Set(["textarea","text","url","tel","search","password","number","email"]).has(e.type)?"typeable-input":"other-input":e.isContentEditable?"contenteditable":"unknown"))).pipe(mergeMap((r=>{switch(r){case"select":return from(t.select(e).then(noop));case"contenteditable":case"typeable-input":return from(t.evaluate(((e,t)=>{const r=e.isContentEditable?e.innerText:e.value;if(t.length<=r.length||!t.startsWith(e.value))return e.isContentEditable?e.innerText="":e.value="",t;const i=e.isContentEditable?e.innerText:e.value;return e.isContentEditable?(e.innerText="",e.innerText=i):(e.value="",e.value=i),t.substring(i.length)}),e)).pipe(mergeMap((e=>from(t.type(e)))));case"other-input":return from(t.focus()).pipe(mergeMap((()=>from(t.evaluate(((e,t)=>{e.value=t,e.dispatchEvent(new Event("input",{bubbles:!0})),e.dispatchEvent(new Event("change",{bubbles:!0}))}),e)))));case"unknown":throw new Error("Element cannot be filled out.")}}))).pipe(catchError(((e,r)=>(t.dispose().catch(debugError),r)))))),this.operators.retryAndRaceWithSignalAndTimer(r))}#l(e){const t=e?.signal;return this._wait(e).pipe(this.operators.conditions([this.#o,this.#n],t),tap((()=>this.emit(LocatorEmittedEvents.Action))),mergeMap((e=>from(e.hover()).pipe(catchError(((t,r)=>(e.dispose().catch(debugError),r)))))),this.operators.retryAndRaceWithSignalAndTimer(t))}#c(e){const t=e?.signal;return this._wait(e).pipe(this.operators.conditions([this.#o,this.#n],t),tap((()=>this.emit(LocatorEmittedEvents.Action))),mergeMap((t=>from(t.evaluate(((e,t,r)=>{void 0!==t&&(e.scrollTop=t),void 0!==r&&(e.scrollLeft=r)}),e?.scrollTop,e?.scrollLeft)).pipe(catchError(((e,r)=>(t.dispose().catch(debugError),r)))))),this.operators.retryAndRaceWithSignalAndTimer(t))}clone(){return this._clone()}async waitHandle(e){return await firstValueFrom(this._wait(e).pipe(this.operators.retryAndRaceWithSignalAndTimer(e?.signal)))}async wait(e){const t=await this.waitHandle(e);try{return await t.jsonValue()}finally{t.dispose().catch(debugError)}}map(e){return new MappedLocator(this._clone(),(t=>t.evaluateHandle(e)))}filter(e){return new FilteredLocator(this._clone(),(async(t,r)=>(await t.frame.waitForFunction(e,{signal:r,timeout:this._timeout},t),!0)))}filterHandle(e){return new FilteredLocator(this._clone(),e)}mapHandle(e){return new MappedLocator(this._clone(),e)}click(e){return firstValueFrom(this.#a(e))}fill(e,t){return firstValueFrom(this.#s(e,t))}hover(e){return firstValueFrom(this.#l(e))}scroll(e){return firstValueFrom(this.#c(e))}}