import*as Common from"../../../../core/common/common.js";import*as Host from"../../../../core/host/host.js";import*as i18n from"../../../../core/i18n/i18n.js";import*as Platform from"../../../../core/platform/platform.js";import*as Root from"../../../../core/root/root.js";import*as SDK from"../../../../core/sdk/sdk.js";import*as IconButton from"../../../components/icon_button/icon_button.js";import*as SrgbOverlay from"../../../components/srgb_overlay/srgb_overlay.js";import*as UI from"../../legacy.js";import{ContrastDetails}from"./ContrastDetails.js";import{FormatPickerContextMenu}from"./FormatPickerContextMenu.js";import{ContrastOverlay}from"./ContrastOverlay.js";import{colorFormatSpec}from"./ColorFormatSpec.js";import spectrumStyles from"./spectrum.css.js";const UIStrings={toggleColorPicker:"Eye dropper [{PH1}]",changeHue:"Change hue",changeAlpha:"Change alpha",hex:"HEX",changeColorFormat:"Change color format",previewPalettes:"Preview palettes",addToPalette:"Add to palette",colorPalettes:"Color Palettes",returnToColorPicker:"Return to color picker",colorS:"Color {PH1}",longclickOrLongpressSpaceToShow:"Long-click or long-press space to show alternate shades of {PH1}",removeColor:"Remove color",removeAllToTheRight:"Remove all to the right",clearPalette:"Clear palette",sInS:"{PH1} in {PH2}",copyColorToClipboard:"Copy color to clipboard",pressArrowKeysMessage:"Press arrow keys with or without modifiers to move swatch position. Arrow key with Shift key moves position largely, with Ctrl key it is less and with Alt key it is even less"},str_=i18n.i18n.registerUIStrings("ui/legacy/components/color_picker/Spectrum.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_),colorElementToMutable=new WeakMap,colorElementToColor=new WeakMap,srgbGamutFormats=["srgb","nickname","rgb","hex","hsl","hwb","shorthex"];function doesFormatSupportDisplayP3(t){return!srgbGamutFormats.includes(t)}function convertColorFormat(t){return"rgba"===t?"rgb":"hsla"===t?"hsl":"hwba"===t?"hwb":"hexa"===t?"hex":"shorthexa"===t?"shorthex":t}function getHsvFromColor(t,e){switch(t){case"display-p3":{const t=e.as("display-p3");return[...Common.Color.rgb2hsv([t.p0,t.p1,t.p2]),t.alpha||1]}case"srgb":return e.as("hsl").hsva()}}function getColorFromHsva(t,e){const o=Common.Color.Legacy.fromHSVA(e);switch(t){case"display-p3":{const t=[0,0,0,0];return Common.Color.hsva2rgba(e,t),new Common.Color.ColorFunction("display-p3",t[0],t[1],t[2],t[3],void 0)}case"srgb":return o}}export class Spectrum extends(Common.ObjectWrapper.eventMixin(UI.Widget.VBox)){colorInternal;gamut="srgb";colorElement;colorDragElement;dragX;dragY;colorPickerButton;swatch;hueElement;hueSlider;alphaElement;alphaElementBackground;alphaSlider;displayContainer;textValues;textLabels;hexContainer;hexValue;contrastInfo;srgbOverlay;contrastOverlay;contrastDetails;contrastDetailsBackgroundColorPickedToggledBound;palettes;palettePanel;palettePanelShowing;paletteSectionContainer;paletteContainer;shadesContainer;deleteIconToolbar;deleteButton;addColorToolbar;colorPickedBound;hsv;hueAlphaWidth;dragWidth;dragHeight;colorDragElementHeight;slideHelperWidth;numPaletteRowsShown;selectedColorPalette;customPaletteSetting;colorOffset;closeButton;paletteContainerMutable;eyeDropperExperimentEnabled;shadesCloseHandler;dragElement;dragHotSpotX;dragHotSpotY;colorNameInternal;colorFormat="rgb";eyeDropperAbortController=null;isFormatPickerShown=!1;colorStringInternal;constructor(t){super(!0),this.contentElement.tabIndex=0,this.colorElement=this.contentElement.createChild("div","spectrum-color"),this.colorElement.tabIndex=0,this.setDefaultFocusedElement(this.colorElement),this.colorElement.addEventListener("keydown",this.onSliderKeydown.bind(this,p.bind(this)));const e=i18nString(UIStrings.pressArrowKeysMessage);UI.ARIAUtils.setLabel(this.colorElement,e),UI.ARIAUtils.markAsApplication(this.colorElement),this.colorDragElement=this.colorElement.createChild("div","spectrum-sat fill").createChild("div","spectrum-val fill").createChild("div","spectrum-dragger"),this.dragX=0,this.dragY=0;const o=this.contentElement.createChild("div","spectrum-tools"),s=new UI.Toolbar.Toolbar("spectrum-eye-dropper",o),i=UI.ShortcutRegistry.ShortcutRegistry.instance().shortcutsForAction("elements.toggle-eye-dropper"),r=i[0]?.descriptors.flatMap((t=>t.name.split(" + ")))[0];this.colorPickerButton=new UI.Toolbar.ToolbarToggle(i18nString(UIStrings.toggleColorPicker,{PH1:r||""}),"color-picker","color-picker-filled"),this.colorPickerButton.setToggled(!0),this.colorPickerButton.addEventListener(UI.Toolbar.ToolbarButton.Events.Click,this.toggleColorPicker.bind(this,void 0)),s.appendToolbarItem(this.colorPickerButton),this.swatch=new Swatch(o),this.hueElement=o.createChild("div","spectrum-hue"),this.hueElement.tabIndex=0,this.hueElement.addEventListener("keydown",this.onSliderKeydown.bind(this,d.bind(this))),UI.ARIAUtils.setLabel(this.hueElement,i18nString(UIStrings.changeHue)),UI.ARIAUtils.markAsSlider(this.hueElement,0,360),this.hueSlider=this.hueElement.createChild("div","spectrum-slider"),this.alphaElement=o.createChild("div","spectrum-alpha"),this.alphaElement.tabIndex=0,this.alphaElement.addEventListener("keydown",this.onSliderKeydown.bind(this,g.bind(this))),UI.ARIAUtils.setLabel(this.alphaElement,i18nString(UIStrings.changeAlpha)),UI.ARIAUtils.markAsSlider(this.alphaElement,0,1),this.alphaElementBackground=this.alphaElement.createChild("div","spectrum-alpha-background"),this.alphaSlider=this.alphaElement.createChild("div","spectrum-slider"),this.displayContainer=o.createChild("div","spectrum-text source-code"),UI.ARIAUtils.markAsPoliteLiveRegion(this.displayContainer,!0),this.textValues=[];for(let t=0;t<4;++t){const t=UI.UIUtils.createInput("spectrum-text-value");this.displayContainer.appendChild(t),t.maxLength=4,this.textValues.push(t),t.addEventListener("keydown",this.inputChanged.bind(this),!1),t.addEventListener("input",this.inputChanged.bind(this),!1),t.addEventListener("wheel",this.inputChanged.bind(this),!1),t.addEventListener("paste",this.pasted.bind(this),!1)}this.textLabels=this.displayContainer.createChild("div","spectrum-text-label"),this.hexContainer=o.createChild("div","spectrum-text spectrum-text-hex source-code"),UI.ARIAUtils.markAsPoliteLiveRegion(this.hexContainer,!0),this.hexValue=UI.UIUtils.createInput("spectrum-text-value"),this.hexContainer.appendChild(this.hexValue),this.hexValue.maxLength=9,this.hexValue.addEventListener("keydown",this.inputChanged.bind(this),!1),this.hexValue.addEventListener("input",this.inputChanged.bind(this),!1),this.hexValue.addEventListener("wheel",this.inputChanged.bind(this),!1),this.hexValue.addEventListener("paste",this.pasted.bind(this),!1);const n=this.hexContainer.createChild("div","spectrum-text-label");n.textContent=i18nString(UIStrings.hex),UI.ARIAUtils.setLabel(this.hexValue,n.textContent);const l=o.createChild("button","spectrum-display-switcher spectrum-switcher");m(l),UI.UIUtils.setTitle(l,i18nString(UIStrings.changeColorFormat)),l.tabIndex=0,l.addEventListener("click",(t=>{this.showFormatPicker(t)})),UI.UIUtils.installDragHandle(this.hueElement,this.dragStart.bind(this,d.bind(this)),d.bind(this),null,"ew-resize","crosshair"),UI.UIUtils.installDragHandle(this.alphaElement,this.dragStart.bind(this,g.bind(this)),g.bind(this),null,"ew-resize","crosshair"),UI.UIUtils.installDragHandle(this.colorElement,this.dragStart.bind(this,p.bind(this)),p.bind(this),null,"move","crosshair"),t&&(this.contrastInfo=t,this.contrastOverlay=new ContrastOverlay(this.contrastInfo,this.colorElement),this.contrastDetails=new ContrastDetails(this.contrastInfo,this.contentElement,this.toggleColorPicker.bind(this),this.contrastPanelExpandedChanged.bind(this),this.colorSelected.bind(this)),this.contrastDetailsBackgroundColorPickedToggledBound=this.contrastDetailsBackgroundColorPickedToggled.bind(this)),this.element.classList.add("flex-none"),this.palettes=new Map,this.palettePanel=this.contentElement.createChild("div","palette-panel"),this.palettePanelShowing=!1,this.paletteSectionContainer=this.contentElement.createChild("div","spectrum-palette-container"),this.paletteContainer=this.paletteSectionContainer.createChild("div","spectrum-palette"),this.paletteContainer.addEventListener("contextmenu",this.showPaletteColorContextMenu.bind(this,-1)),this.shadesContainer=this.contentElement.createChild("div","palette-color-shades hidden"),UI.UIUtils.installDragHandle(this.paletteContainer,this.paletteDragStart.bind(this),this.paletteDrag.bind(this),this.paletteDragEnd.bind(this),"default");const a=this.paletteSectionContainer.createChild("div","spectrum-palette-switcher spectrum-switcher");m(a),UI.UIUtils.setTitle(a,i18nString(UIStrings.previewPalettes)),UI.ARIAUtils.markAsButton(a),a.tabIndex=0,self.onInvokeElement(a,(t=>{this.togglePalettePanel(!0),t.consume(!0)})),this.deleteIconToolbar=new UI.Toolbar.Toolbar("delete-color-toolbar"),this.deleteButton=new UI.Toolbar.ToolbarButton("","bin"),this.deleteIconToolbar.appendToolbarItem(this.deleteButton);this.contentElement.createChild("div","spectrum-overlay fill").addEventListener("click",this.togglePalettePanel.bind(this,!1)),this.addColorToolbar=new UI.Toolbar.Toolbar("add-color-toolbar");const h=new UI.Toolbar.ToolbarButton(i18nString(UIStrings.addToPalette),"plus");function c(t,e){const o=e,s=t.getBoundingClientRect();switch(o.key){case"ArrowLeft":case"ArrowDown":return s.left-1;case"ArrowRight":case"ArrowUp":return s.right+1;default:return e.x}}function d(t){const e=this.hsv.slice(),o=1-(c(this.hueSlider,t)-this.hueElement.getBoundingClientRect().left)/this.hueAlphaWidth;e[0]=Platform.NumberUtilities.clamp(o,0,1),this.innerSetColor(e,"",void 0,void 0,ChangeSource.Other);const s=getColorFromHsva(this.gamut,e).as("hsl").canonicalHSLA();UI.ARIAUtils.setValueNow(this.hueElement,s[0])}function g(t){const e=this.hsv.slice(),o=(c(this.alphaSlider,t)-this.hueElement.getBoundingClientRect().left)/this.hueAlphaWidth,s=Math.round(100*o)/100;e[3]=Platform.NumberUtilities.clamp(s,0,1),this.innerSetColor(e,"",void 0,void 0,ChangeSource.Other);const i=getColorFromHsva(this.gamut,e).as("hsl").canonicalHSLA();UI.ARIAUtils.setValueText(this.alphaElement,i[3])}function p(t){const e=this.hsv.slice(),o=function(t,e){const o=t.getBoundingClientRect(),s=o.x+o.width/2,i=o.y+o.width/2,r=function(t,e){const o=e;o.altKey?t=1:o.ctrlKey?t=10:o.shiftKey&&(t=20);return t}(o.width/4,e);switch(e.key){case"ArrowLeft":return{x:o.left-r,y:i};case"ArrowRight":return{x:o.right+r,y:i};case"ArrowDown":return{x:s,y:o.bottom+r};case"ArrowUp":return{x:s,y:o.top-r};default:return{x:e.x,y:e.y}}}(this.colorDragElement,t);this.colorOffset=this.colorElement.getBoundingClientRect(),e[1]=Platform.NumberUtilities.clamp((o.x-this.colorOffset.left)/this.dragWidth,0,1),e[2]=Platform.NumberUtilities.clamp(1-(o.y-this.colorOffset.top)/this.dragHeight,0,1),this.innerSetColor(e,"",void 0,void 0,ChangeSource.Other)}function m(t){const e=new IconButton.Icon.Icon;e.data={iconName:"fold-more",color:"var(--icon-default)",width:"16px",height:"16px"},t.appendChild(e)}h.addEventListener(UI.Toolbar.ToolbarButton.Events.Click,this.onAddColorMousedown.bind(this)),h.element.addEventListener("keydown",this.onAddColorKeydown.bind(this)),this.addColorToolbar.appendToolbarItem(h),this.colorPickedBound=this.colorPicked.bind(this),this.numPaletteRowsShown=-1,this.contentElement.addEventListener("focusout",(t=>{this.isFormatPickerShown&&t.stopImmediatePropagation()})),this.srgbOverlay=new SrgbOverlay.SrgbOverlay.SrgbOverlay,this.loadPalettes(),new PaletteGenerator((t=>{t.colors.length?this.addPalette(t):this.selectedColorPalette.get()===t.title&&this.paletteSelected(MaterialPalette)}))}dragStart(t,e){return this.colorOffset=this.colorElement.getBoundingClientRect(),t(e),!0}contrastDetailsBackgroundColorPickedToggled(t){t.data&&this.toggleColorPicker(!1)}contrastPanelExpandedChanged(){this.contrastOverlay&&this.contrastDetails&&(this.contrastOverlay.setVisible(this.contrastDetails.expanded()),this.resizeForSelectedPalette(!0),this.contrastDetails.expanded()?this.hideSrgbOverlay():this.showSrgbOverlay())}updatePalettePanel(){this.palettePanel.removeChildren();this.palettePanel.createChild("div","palette-title").textContent=i18nString(UIStrings.colorPalettes);const t=new UI.Toolbar.Toolbar("",this.palettePanel);this.closeButton=new UI.Toolbar.ToolbarButton(i18nString(UIStrings.returnToColorPicker),"cross"),this.closeButton.addEventListener(UI.Toolbar.ToolbarButton.Events.Click,this.togglePalettePanel.bind(this,!1)),this.closeButton.element.addEventListener("keydown",this.onCloseBtnKeydown.bind(this)),t.appendToolbarItem(this.closeButton);for(const t of this.palettes.values())this.palettePanel.appendChild(this.createPreviewPaletteElement(t));this.contentElement.scrollIntoView({block:"end"})}togglePalettePanel(t){this.palettePanelShowing!==t&&(t&&this.updatePalettePanel(),this.palettePanelShowing=t,this.contentElement.classList.toggle("palette-panel-showing",t),this.focusInternal())}onCloseBtnKeydown(t){(Platform.KeyboardUtilities.isEscKey(t)||Platform.KeyboardUtilities.isEnterOrSpaceKey(t))&&(this.togglePalettePanel(!1),t.consume(!0))}onSliderKeydown(t,e){switch(e.key){case"ArrowLeft":case"ArrowRight":case"ArrowDown":case"ArrowUp":t(e),e.consume(!0)}}focusInternal(){this.isShowing()&&(this.palettePanelShowing&&this.closeButton?this.closeButton.element.focus({preventScroll:!0}):this.contentElement.focus())}createPaletteColor(t,e,o){const s=document.createElement("div");return s.classList.add("spectrum-palette-color"),s.style.background=Platform.StringUtilities.sprintf("linear-gradient(%s, %s), var(--image-file-checker)",t,t),o&&s.animate([{opacity:0},{opacity:1}],{duration:100,delay:o,fill:"backwards"}),UI.Tooltip.Tooltip.install(s,e||t),s}showPalette(t,e,o){this.resizeForSelectedPalette(),this.paletteContainer.removeChildren();for(let o=0;o<t.colors.length;o++){const s=e?100*o/t.colors.length:0,i=this.createPaletteColor(t.colors[o],t.colorNames[o],s);if(UI.ARIAUtils.markAsButton(i),UI.ARIAUtils.setLabel(i,i18nString(UIStrings.colorS,{PH1:t.colors[o]})),i.tabIndex=-1,i.addEventListener("mousedown",this.paletteColorSelected.bind(this,t.colors[o],t.colorNames[o],Boolean(t.matchUserFormat))),i.addEventListener("focus",this.paletteColorSelected.bind(this,t.colors[o],t.colorNames[o],Boolean(t.matchUserFormat))),i.addEventListener("keydown",this.onPaletteColorKeydown.bind(this,o)),t.mutable)colorElementToMutable.set(i,!0),colorElementToColor.set(i,t.colors[o]),i.addEventListener("contextmenu",this.showPaletteColorContextMenu.bind(this,o));else if(t===MaterialPalette){i.classList.add("has-material-shades");let e=i.createChild("div","spectrum-palette-color spectrum-palette-color-shadow");e.style.background=t.colors[o],e=i.createChild("div","spectrum-palette-color spectrum-palette-color-shadow"),e.style.background=t.colors[o];const s=i18nString(UIStrings.longclickOrLongpressSpaceToShow,{PH1:t.colors[o]});UI.Tooltip.Tooltip.install(i,s),UI.ARIAUtils.setLabel(i,s),new UI.UIUtils.LongClickController(i,this.showLightnessShades.bind(this,i,t.colors[o]))}this.paletteContainer.appendChild(i)}this.paletteContainer.childNodes.length>0&&(this.paletteContainer.childNodes[0].tabIndex=0),this.paletteContainerMutable=t.mutable,t.mutable?(this.paletteContainer.appendChild(this.addColorToolbar.element),this.paletteContainer.appendChild(this.deleteIconToolbar.element)):(this.addColorToolbar.element.remove(),this.deleteIconToolbar.element.remove()),this.togglePalettePanel(!1),this.focusInternal()}showLightnessShades(t,e,o){this.shadesCloseHandler&&this.shadesCloseHandler(),this.shadesContainer.classList.remove("hidden"),this.shadesContainer.removeChildren(),this.shadesContainer.animate([{transform:"scaleY(0)",opacity:"0"},{transform:"scaleY(1)",opacity:"1"}],{duration:200,easing:"cubic-bezier(0.4, 0, 0.2, 1)"});let s=this.paletteContainer.offsetTop+t.offsetTop+(t.parentElement?t.parentElement.offsetTop:0);this.contrastDetails&&(s+=this.contrastDetails.element().offsetHeight),this.shadesContainer.style.top=s+"px",this.shadesContainer.style.left=t.offsetLeft+"px",t.classList.add("spectrum-shades-shown");const i=MaterialPaletteShades.get(e);if(void 0!==i)for(let e=i.length-1;e>=0;e--){const o=this.createPaletteColor(i[e],void 0,200*e/i.length+100);UI.ARIAUtils.markAsButton(o),UI.ARIAUtils.setLabel(o,i18nString(UIStrings.colorS,{PH1:i[e]})),o.tabIndex=-1,o.addEventListener("mousedown",this.paletteColorSelected.bind(this,i[e],i[e],!1)),o.addEventListener("focus",this.paletteColorSelected.bind(this,i[e],i[e],!1)),o.addEventListener("keydown",this.onShadeColorKeydown.bind(this,t)),this.shadesContainer.appendChild(o)}this.shadesContainer.childNodes.length>0&&this.shadesContainer.childNodes[this.shadesContainer.childNodes.length-1].focus(),this.shadesCloseHandler=function(t){this.shadesContainer.classList.add("hidden"),t.classList.remove("spectrum-shades-shown"),this.shadesCloseHandler&&this.shadesContainer.ownerDocument.removeEventListener("mousedown",this.shadesCloseHandler,!0),delete this.shadesCloseHandler}.bind(this,t),this.shadesContainer.ownerDocument.addEventListener("mousedown",this.shadesCloseHandler,!0)}slotIndexForEvent(t){const e=t,o=e.pageX-this.paletteContainer.getBoundingClientRect().left,s=e.pageY-this.paletteContainer.getBoundingClientRect().top,i=Math.min(o/COLOR_CHIP_SIZE|0,ITEMS_PER_PALETTE_ROW-1),r=s/COLOR_CHIP_SIZE|0;return Math.min(r*ITEMS_PER_PALETTE_ROW+i,this.customPaletteSetting.get().colors.length-1)}isDraggingToBin(t){return t.pageX>this.deleteIconToolbar.element.getBoundingClientRect().left}paletteDragStart(t){const e=UI.UIUtils.deepElementFromEvent(t);if(!e||!colorElementToMutable.get(e))return!1;const o=this.slotIndexForEvent(t);this.dragElement=e;const s=t;return this.dragHotSpotX=s.pageX-o%ITEMS_PER_PALETTE_ROW*COLOR_CHIP_SIZE,this.dragHotSpotY=s.pageY-(o/ITEMS_PER_PALETTE_ROW|0)*COLOR_CHIP_SIZE,!0}paletteDrag(t){const e=t;if(e.pageX<this.paletteContainer.getBoundingClientRect().left||e.pageY<this.paletteContainer.getBoundingClientRect().top)return;if(!this.dragElement||void 0===this.dragHotSpotX||void 0===this.dragHotSpotY)return;const o=this.slotIndexForEvent(t),s=e.pageX-o%ITEMS_PER_PALETTE_ROW*COLOR_CHIP_SIZE,i=e.pageY-(o/ITEMS_PER_PALETTE_ROW|0)*COLOR_CHIP_SIZE,r=this.isDraggingToBin(t);this.deleteIconToolbar.element.classList.add("dragging"),this.deleteIconToolbar.element.classList.toggle("delete-color-toolbar-active",r);const n="translateX("+(s-this.dragHotSpotX)+"px) translateY("+(i-this.dragHotSpotY)+"px)";this.dragElement.style.transform=r?n+" scale(0.8)":n;const l=[...this.paletteContainer.children],a=l.indexOf(this.dragElement),h=new Map;for(const t of l)h.set(t,t.getBoundingClientRect());a!==o&&this.paletteContainer.insertBefore(this.dragElement,l[o>a?o+1:o]);for(const t of l){if(t===this.dragElement)continue;const e=h.get(t),o=t.getBoundingClientRect();!e||e.left===o.left&&e.top===o.top||t.animate([{transform:"translateX("+(e.left-o.left)+"px) translateY("+(e.top-o.top)+"px)"},{transform:"none"}],{duration:100,easing:"cubic-bezier(0, 0, 0.2, 1)"})}}paletteDragEnd(t){if(!this.dragElement)return;this.isDraggingToBin(t)&&this.dragElement.remove(),this.dragElement.style.removeProperty("transform");const e=this.paletteContainer.children,o=[];for(let t=0;t<e.length;++t){const s=colorElementToColor.get(e[t]);s&&o.push(s)}const s=this.customPaletteSetting.get();s.colors=o,this.customPaletteSetting.set(s),this.showPalette(s,!1),this.deleteIconToolbar.element.classList.remove("dragging"),this.deleteIconToolbar.element.classList.remove("delete-color-toolbar-active")}loadPalettes(){this.palettes.set(MaterialPalette.title,MaterialPalette);const t={title:"Custom",colors:[],colorNames:[],mutable:!0,matchUserFormat:void 0};this.customPaletteSetting=Common.Settings.Settings.instance().createSetting("customColorPalette",t);const e=this.customPaletteSetting.get();e.colorNames=e.colorNames||[],this.palettes.set(e.title,e),this.selectedColorPalette=Common.Settings.Settings.instance().createSetting("selectedColorPalette",GeneratedPaletteTitle);const o=this.palettes.get(this.selectedColorPalette.get());o&&this.showPalette(o,!0)}addPalette(t){this.palettes.set(t.title,t),this.selectedColorPalette.get()===t.title&&this.showPalette(t,!0)}createPreviewPaletteElement(t){const e=document.createElement("div");e.classList.add("palette-preview"),UI.ARIAUtils.markAsButton(e),e.tabIndex=0;let o;for(e.createChild("div","palette-preview-title").textContent=t.title,o=0;o<5&&o<t.colors.length;o++)e.appendChild(this.createPaletteColor(t.colors[o],t.colorNames[o]));for(;o<5;o++)e.createChild("div","spectrum-palette-color empty-color");return self.onInvokeElement(e,(e=>{this.paletteSelected(t),e.consume(!0)})),e}paletteSelected(t){this.selectedColorPalette.set(t.title),this.showPalette(t,!0)}resizeForSelectedPalette(t){const e=this.palettes.get(this.selectedColorPalette.get());if(!e)return;let o=e.colors.length;e===this.customPaletteSetting.get()&&o++;const s=Math.max(1,Math.ceil(o/ITEMS_PER_PALETTE_ROW));if(this.numPaletteRowsShown===s&&!t)return;this.numPaletteRowsShown=s;let i=236;this.contrastDetails&&(this.contrastDetails.expanded()?i+=78:i+=36),this.element.style.height=i+12+24*s+"px",this.dispatchEventToListeners(Events.SizeChanged)}paletteColorSelected(t,e,o){const s=Common.Color.parse(t);s&&this.innerSetColor(s,t,e,o?this.colorFormat:s.format(),ChangeSource.Other)}onPaletteColorKeydown(t,e){let o;switch(e.key){case"ArrowLeft":o=t-1;break;case"ArrowRight":o=t+1;break;case"ArrowUp":o=t-ITEMS_PER_PALETTE_ROW;break;case"ArrowDown":o=t+ITEMS_PER_PALETTE_ROW}void 0!==o&&o>-1&&o<this.paletteContainer.childNodes.length&&this.paletteContainer.childNodes[o].focus()}onShadeColorKeydown(t,e){const o=e.target;Platform.KeyboardUtilities.isEscKey(e)||"Tab"===e.key?(t.focus(),this.shadesCloseHandler&&this.shadesCloseHandler(),e.consume(!0)):"ArrowUp"===e.key&&o.previousElementSibling?(o.previousElementSibling.focus(),e.consume(!0)):"ArrowDown"===e.key&&o.nextElementSibling&&(o.nextElementSibling.focus(),e.consume(!0))}onAddColorMousedown(){this.addColorToCustomPalette()}onAddColorKeydown(t){Platform.KeyboardUtilities.isEnterOrSpaceKey(t)&&(this.addColorToCustomPalette(),t.consume(!0))}addColorToCustomPalette(){const t=this.customPaletteSetting.get();t.colors.push(this.colorString()),this.customPaletteSetting.set(t),this.showPalette(t,!1);const e=this.paletteContainer.querySelectorAll(".spectrum-palette-color");e[e.length-1].focus()}showPaletteColorContextMenu(t,e){if(!this.paletteContainerMutable)return;const o=new UI.ContextMenu.ContextMenu(e);-1!==t&&(o.defaultSection().appendItem(i18nString(UIStrings.removeColor),this.deletePaletteColors.bind(this,t,!1)),o.defaultSection().appendItem(i18nString(UIStrings.removeAllToTheRight),this.deletePaletteColors.bind(this,t,!0))),o.defaultSection().appendItem(i18nString(UIStrings.clearPalette),this.deletePaletteColors.bind(this,-1,!0)),o.show()}deletePaletteColors(t,e){const o=this.customPaletteSetting.get();e?o.colors.splice(t+1,o.colors.length-t-1):o.colors.splice(t,1),this.customPaletteSetting.set(o),this.showPalette(o,!1)}setColor(t,e){this.innerSetColor(t,"",void 0,e,ChangeSource.Model);const o=t.as("hsl").canonicalHSLA();UI.ARIAUtils.setValueNow(this.hueElement,o[0]),UI.ARIAUtils.setValueText(this.alphaElement,o[3])}colorSelected(t){this.innerSetColor(t,"",void 0,void 0,ChangeSource.Other)}get color(){return this.colorInternal?this.colorInternal:getColorFromHsva(this.gamut,this.hsv)}innerSetColor(t,e,o,s,i){if(void 0!==e&&(this.colorStringInternal=e),void 0!==s&&(this.colorFormat=convertColorFormat(s),this.gamut=doesFormatSupportDisplayP3(this.colorFormat)?"display-p3":"srgb"),Array.isArray(t))this.colorInternal=void 0,this.hsv=t;else if(void 0!==t){this.colorInternal=t;const e=this.hsv?this.hsv[0]:null;this.hsv=getHsvFromColor(this.gamut,t),null!==e&&t.as("lch").isHuePowerless()&&(this.hsv[0]=e)}this.colorNameInternal=o,this.contrastInfo&&this.contrastInfo.setColor(Common.Color.Legacy.fromHSVA(this.hsv),this.colorFormat),this.updateHelperLocations(),this.updateUI(),i!==ChangeSource.Input&&this.updateInput(),i!==ChangeSource.Model&&this.dispatchEventToListeners(Events.ColorChanged,this.colorString())}colorName(){return this.colorNameInternal}colorString(){if(this.colorStringInternal)return this.colorStringInternal;const t=this.color;let e=this.colorFormat&&this.colorFormat!==t.format()?t.asString(this.colorFormat):t.getAuthoredText()??t.asString();return e||(e="nickname"===this.colorFormat?t.asString(t.asLegacyColor().hasAlpha()?"hexa":"hex"):"shorthex"===this.colorFormat?t.asString(t.asLegacyColor().detectHEXFormat()):"hex"===this.colorFormat?t.asString("hexa"):"hsl"===this.colorFormat?t.asString("hsla"):"hwb"===this.colorFormat?t.asString("hwba"):t.asString("rgba"),console.assert(Boolean(e)),e||"")}updateHelperLocations(){const t=this.hsv[0],e=this.hsv[1],o=this.hsv[2],s=this.hsv[3];this.dragX=e*this.dragWidth,this.dragY=this.dragHeight-o*this.dragHeight;const i=Math.max(-this.colorDragElementHeight,Math.min(this.dragWidth-this.colorDragElementHeight,this.dragX-this.colorDragElementHeight)),r=Math.max(-this.colorDragElementHeight,Math.min(this.dragHeight-this.colorDragElementHeight,this.dragY-this.colorDragElementHeight));this.colorDragElement.positionAt(i,r);const n=(1-t)*this.hueAlphaWidth-this.slideHelperWidth;this.hueSlider.style.left=n+"px";const l=s*this.hueAlphaWidth-this.slideHelperWidth;this.alphaSlider.style.left=l+"px"}updateInput(){if("hex"===this.colorFormat||"shorthex"===this.colorFormat||"nickname"===this.colorFormat)this.hexContainer.hidden=!1,this.displayContainer.hidden=!0,"shorthex"===this.colorFormat?this.hexValue.value=String(this.color.asString(this.color.asLegacyColor().detectHEXFormat())):this.hexValue.value=String(this.color.asString(this.color.asLegacyColor().hasAlpha()?"hexa":"hex"));else{this.hexContainer.hidden=!0,this.displayContainer.hidden=!1;const t=colorFormatSpec[this.colorFormat],e=t.toValues(this.color);this.textLabels.textContent=t.label;for(let t=0;t<this.textValues.length;++t)UI.ARIAUtils.setLabel(this.textValues[t],i18nString(UIStrings.sInS,{PH1:this.textLabels.textContent.charAt(t),PH2:this.textLabels.textContent})),this.textValues[t].value=String(e[t])}}hideSrgbOverlay(){this.colorElement.contains(this.srgbOverlay)&&this.colorElement.removeChild(this.srgbOverlay)}showSrgbOverlay(){this.contrastDetails&&this.contrastDetails.expanded()||"display-p3"!==this.gamut||(this.srgbOverlay.render({hue:this.hsv[0],width:this.dragWidth,height:this.dragHeight}),this.colorElement.contains(this.srgbOverlay)||this.colorElement.appendChild(this.srgbOverlay))}updateSrgbOverlay(){"display-p3"===this.gamut?this.showSrgbOverlay():this.hideSrgbOverlay()}updateUI(){this.colorElement.style.backgroundColor=getColorFromHsva(this.gamut,[this.hsv[0],1,1,1]).asString(),this.contrastOverlay&&this.contrastOverlay.setDimensions(this.dragWidth,this.dragHeight),this.updateSrgbOverlay(),this.swatch.setColor(this.color,this.colorString()),this.colorDragElement.style.backgroundColor=this.color.asString("lch");const t=Common.Color.Legacy.fromHSVA(this.hsv.slice(0,3).concat(1));this.alphaElementBackground.style.backgroundImage=Platform.StringUtilities.sprintf("linear-gradient(to right, rgba(0,0,0,0), %s)",t.asString("lch")),this.hueElement.classList.toggle("display-p3",doesFormatSupportDisplayP3(this.colorFormat))}async showFormatPicker(t){const e=new FormatPickerContextMenu(this.color,this.colorFormat);this.isFormatPickerShown=!0,await e.show(t,(t=>{const e=this.color.as(t);this.innerSetColor(e,void 0,void 0,t,ChangeSource.Other),Host.userMetrics.colorConvertedFrom(1)})),this.isFormatPickerShown=!1}pasted(t){if(!t.clipboardData)return;const e=t.clipboardData.getData("text"),o=Common.Color.parse(e);o&&(this.innerSetColor(o,e,void 0,void 0,ChangeSource.Other),t.preventDefault())}inputChanged(t){const e=t.currentTarget,o=UI.UIUtils.createReplacementString(e.value,t);o&&(e.value=o,e.selectionStart=0,e.selectionEnd=o.length,t.consume(!0));let s=null;if("hex"===this.colorFormat||"shorthex"===this.colorFormat||"nickname"===this.colorFormat)s=Common.Color.parse(this.hexValue.value);else{const t=colorFormatSpec[this.colorFormat],e=this.textValues.map((t=>t.value));if(4!==e.length)return;s=t.fromValues(e)}s&&this.innerSetColor(s,void 0,void 0,undefined,ChangeSource.Input)}wasShown(){this.registerCSSFiles([spectrumStyles]),this.hueAlphaWidth=this.hueElement.offsetWidth,this.slideHelperWidth=this.hueSlider.offsetWidth/2,this.dragWidth=this.colorElement.offsetWidth,this.dragHeight=this.colorElement.offsetHeight,this.colorDragElementHeight=this.colorDragElement.offsetHeight/2,this.innerSetColor(void 0,void 0,void 0,void 0,ChangeSource.Model),this.eyeDropperExperimentEnabled=Root.Runtime.experiments.isEnabled(Root.Runtime.ExperimentName.EYEDROPPER_COLOR_PICKER),this.eyeDropperExperimentEnabled?this.colorPickerButton.setToggled(!1):this.toggleColorPicker(!0),this.contrastDetails&&this.contrastDetailsBackgroundColorPickedToggledBound&&this.contrastDetails.addEventListener("BackgroundColorPickerWillBeToggled",this.contrastDetailsBackgroundColorPickedToggledBound)}willHide(){this.toggleColorPicker(!1),this.contrastDetails&&this.contrastDetailsBackgroundColorPickedToggledBound&&this.contrastDetails.removeEventListener("BackgroundColorPickerWillBeToggled",this.contrastDetailsBackgroundColorPickedToggledBound)}async toggleColorPicker(t){const e=this.eyeDropperExperimentEnabled;if(void 0===t&&(t=!this.colorPickerButton.toggled()),this.colorPickerButton.setToggled(t),this.contrastDetails&&t&&this.contrastDetails.backgroundColorPickerEnabled()&&this.contrastDetails.toggleBackgroundColorPicker(!1),e)if(e&&t){const t=new window.EyeDropper;this.eyeDropperAbortController=new AbortController;try{const e=await t.open({signal:this.eyeDropperAbortController.signal}),o=Common.Color.parse(e.sRGBHex);this.innerSetColor(o??void 0,"",void 0,void 0,ChangeSource.Other)}catch(t){"AbortError"!==t.name&&console.error(t)}this.colorPickerButton.setToggled(!1)}else e&&!t&&(this.eyeDropperAbortController?.abort(),this.eyeDropperAbortController=null);else Host.InspectorFrontendHost.InspectorFrontendHostInstance.setEyeDropperActive(t),t?Host.InspectorFrontendHost.InspectorFrontendHostInstance.events.addEventListener(Host.InspectorFrontendHostAPI.Events.EyeDropperPickedColor,this.colorPickedBound):Host.InspectorFrontendHost.InspectorFrontendHostInstance.events.removeEventListener(Host.InspectorFrontendHostAPI.Events.EyeDropperPickedColor,this.colorPickedBound)}colorPicked({data:t}){const e=[t.r,t.g,t.b,(t.a/2.55|0)/100],o=Common.Color.Legacy.fromRGBA(e);this.innerSetColor(o,"",void 0,void 0,ChangeSource.Other),Host.InspectorFrontendHost.InspectorFrontendHostInstance.bringToFront()}}export const ChangeSource={Input:"Input",Model:"Model",Other:"Other"};export var Events;!function(t){t.ColorChanged="ColorChanged",t.SizeChanged="SizeChanged"}(Events||(Events={}));const COLOR_CHIP_SIZE=24,ITEMS_PER_PALETTE_ROW=8,GeneratedPaletteTitle="Page colors";export class PaletteGenerator{callback;frequencyMap;constructor(t){this.callback=t,this.frequencyMap=new Map;const e=[];for(const t of SDK.TargetManager.TargetManager.instance().models(SDK.CSSModel.CSSModel))for(const o of t.allStyleSheets())e.push(this.processStylesheet(o));Promise.all(e).catch((t=>{console.error(t)})).then(this.finish.bind(this))}frequencyComparator(t,e){return this.frequencyMap.get(e)-this.frequencyMap.get(t)}finish(){let t=[...this.frequencyMap.keys()];t=t.sort(this.frequencyComparator.bind(this));const e=new Map;for(;e.size<24&&t.length;){const o=t.shift(),s=Common.Color.parse(o);s&&e.set(o,s)}this.callback({title:GeneratedPaletteTitle,colors:[...e.keys()].sort((function(t,o){const s=e.get(t).as("hsl").hsva(),i=e.get(o).as("hsl").hsva();return i[1]<.12&&s[1]<.12?i[2]*i[3]-s[2]*s[3]:i[1]<.12?-1:s[1]<.12?1:i[0]===s[0]?i[1]*i[3]-s[1]*s[3]:(i[0]+.94)%1-(s[0]+.94)%1})),colorNames:[],mutable:!1,matchUserFormat:void 0})}async processStylesheet(t){let e=(await t.requestContent()).content||"";e=e.toLowerCase();const o=e.match(/((?:rgb|hsl|hwb)a?\([^)]+\)|#[0-9a-f]{6}|#[0-9a-f]{3})/g)||[];for(const t of o){let e=this.frequencyMap.get(t)||0;this.frequencyMap.set(t,++e)}}}const MaterialPaletteShades=new Map([["#F44336",["#FFEBEE","#FFCDD2","#EF9A9A","#E57373","#EF5350","#F44336","#E53935","#D32F2F","#C62828","#B71C1C"]],["#E91E63",["#FCE4EC","#F8BBD0","#F48FB1","#F06292","#EC407A","#E91E63","#D81B60","#C2185B","#AD1457","#880E4F"]],["#9C27B0",["#F3E5F5","#E1BEE7","#CE93D8","#BA68C8","#AB47BC","#9C27B0","#8E24AA","#7B1FA2","#6A1B9A","#4A148C"]],["#673AB7",["#EDE7F6","#D1C4E9","#B39DDB","#9575CD","#7E57C2","#673AB7","#5E35B1","#512DA8","#4527A0","#311B92"]],["#3F51B5",["#E8EAF6","#C5CAE9","#9FA8DA","#7986CB","#5C6BC0","#3F51B5","#3949AB","#303F9F","#283593","#1A237E"]],["#2196F3",["#E3F2FD","#BBDEFB","#90CAF9","#64B5F6","#42A5F5","#2196F3","#1E88E5","#1976D2","#1565C0","#0D47A1"]],["#03A9F4",["#E1F5FE","#B3E5FC","#81D4FA","#4FC3F7","#29B6F6","#03A9F4","#039BE5","#0288D1","#0277BD","#01579B"]],["#00BCD4",["#E0F7FA","#B2EBF2","#80DEEA","#4DD0E1","#26C6DA","#00BCD4","#00ACC1","#0097A7","#00838F","#006064"]],["#009688",["#E0F2F1","#B2DFDB","#80CBC4","#4DB6AC","#26A69A","#009688","#00897B","#00796B","#00695C","#004D40"]],["#4CAF50",["#E8F5E9","#C8E6C9","#A5D6A7","#81C784","#66BB6A","#4CAF50","#43A047","#388E3C","#2E7D32","#1B5E20"]],["#8BC34A",["#F1F8E9","#DCEDC8","#C5E1A5","#AED581","#9CCC65","#8BC34A","#7CB342","#689F38","#558B2F","#33691E"]],["#CDDC39",["#F9FBE7","#F0F4C3","#E6EE9C","#DCE775","#D4E157","#CDDC39","#C0CA33","#AFB42B","#9E9D24","#827717"]],["#FFEB3B",["#FFFDE7","#FFF9C4","#FFF59D","#FFF176","#FFEE58","#FFEB3B","#FDD835","#FBC02D","#F9A825","#F57F17"]],["#FFC107",["#FFF8E1","#FFECB3","#FFE082","#FFD54F","#FFCA28","#FFC107","#FFB300","#FFA000","#FF8F00","#FF6F00"]],["#FF9800",["#FFF3E0","#FFE0B2","#FFCC80","#FFB74D","#FFA726","#FF9800","#FB8C00","#F57C00","#EF6C00","#E65100"]],["#FF5722",["#FBE9E7","#FFCCBC","#FFAB91","#FF8A65","#FF7043","#FF5722","#F4511E","#E64A19","#D84315","#BF360C"]],["#795548",["#EFEBE9","#D7CCC8","#BCAAA4","#A1887F","#8D6E63","#795548","#6D4C41","#5D4037","#4E342E","#3E2723"]],["#9E9E9E",["#FAFAFA","#F5F5F5","#EEEEEE","#E0E0E0","#BDBDBD","#9E9E9E","#757575","#616161","#424242","#212121"]],["#607D8B",["#ECEFF1","#CFD8DC","#B0BEC5","#90A4AE","#78909C","#607D8B","#546E7A","#455A64","#37474F","#263238"]]]);export const MaterialPalette={title:"Material",mutable:!1,matchUserFormat:!0,colors:[...MaterialPaletteShades.keys()],colorNames:[]};export class Swatch{colorString;swatchInnerElement;swatchOverlayElement;swatchCopyIcon;constructor(t){const e=t.createChild("span","swatch");this.swatchInnerElement=e.createChild("span","swatch-inner"),this.swatchOverlayElement=e.createChild("span","swatch-overlay"),UI.ARIAUtils.markAsButton(this.swatchOverlayElement),UI.ARIAUtils.setPressed(this.swatchOverlayElement,!1),this.swatchOverlayElement.tabIndex=0,self.onInvokeElement(this.swatchOverlayElement,this.onCopyText.bind(this)),this.swatchOverlayElement.addEventListener("mouseout",this.onCopyIconMouseout.bind(this)),this.swatchOverlayElement.addEventListener("blur",this.onCopyIconMouseout.bind(this)),this.swatchCopyIcon=UI.Icon.Icon.create("copy","copy-color-icon"),UI.Tooltip.Tooltip.install(this.swatchCopyIcon,i18nString(UIStrings.copyColorToClipboard)),this.swatchOverlayElement.appendChild(this.swatchCopyIcon),UI.ARIAUtils.setLabel(this.swatchOverlayElement,this.swatchCopyIcon.title)}setColor(t,e){const o=t.as("lch");this.swatchInnerElement.style.backgroundColor=o.asString(),this.swatchInnerElement.classList.toggle("swatch-inner-white",o.l>90),this.colorString=e||null,this.swatchOverlayElement.hidden=!e}onCopyText(t){this.swatchCopyIcon.setIconType("checkmark"),Host.InspectorFrontendHost.InspectorFrontendHostInstance.copyText(this.colorString),UI.ARIAUtils.setPressed(this.swatchOverlayElement,!0),t.consume()}onCopyIconMouseout(){this.swatchCopyIcon.setIconType("copy"),UI.ARIAUtils.setPressed(this.swatchOverlayElement,!1)}}